﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Documents.Excel;

namespace WorkbooksToSheets
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            var dirPath = @"..\..\Workbooks";
            var resultFilename = @"..\..\Result\ResultWorkbook.xlsx";

            var excelFiles = Directory.EnumerateFiles(dirPath)
            .Where(f => f.EndsWith(".xlsx") || f.EndsWith(".xls")).ToList();

            if (excelFiles.Count == 0)
            {
                MessageBox.Show("No excel files were found in the directory");
                return;
            }

            var resultWorkbook = new Workbook(WorkbookFormat.Excel2007);

            for (int i = 0; i < excelFiles.Count; i++)
            {
                var tempWorkbook = Workbook.Load(excelFiles[i]);

                resultWorkbook.Worksheets.Add("Sheet" + ( i + 1));

                foreach (var row in tempWorkbook.Worksheets[0].Rows)
                {
                    var rowIndex = row.Index;
                    var resultRow = resultWorkbook.Worksheets[i].Rows[rowIndex];

                    resultRow.Height = row.Height;
                    resultRow.CellFormat.SetFormatting(row.CellFormat);

                    foreach (var cell in row.Cells)
                    {
                        var resultCell = resultRow.Cells[cell.ColumnIndex];
                        if (cell.Formula == null)
                        {
                            resultCell.Value = cell.Value;
                        }
                        else
                        {
                            cell.Formula.ApplyTo(resultCell);
                        }
                        resultCell.CellFormat.SetFormatting(cell.CellFormat);
                    }

                }

                foreach (var column in tempWorkbook.Worksheets[0].Columns)
                {
                    var columnIndex = column.Index;
                    var resultColumn = resultWorkbook.Worksheets[i].Columns[columnIndex];

                    resultColumn.Width = column.Width;
                    resultColumn.CellFormat.SetFormatting(column.CellFormat);
                }
                
            }

            resultWorkbook.Save(resultFilename);
            Process.Start(resultFilename);
            
        }

    }
}
